config/routes.rb
Rails.application.routes.draw do


  root to: "home#index"

  # Devise
  devise_for :users, controllers: { registrations: 'users/registrations' }
  
  # Users
  resources :users, only: [:index, :show, :edit, :update] do
    resources :follows, only: [:index, :create, :destroy]
    resources :bookmarks, only: [:index, :create, :destroy]
  end
  
  # Articles
  resources :articles do
    collection do 
      get :my
    end
    
    # Alternatives
    resources :alternatives, shallow: true do
      collection do
        post :update_all
      end
    end

    # Criteria
    resources :criteria, only: [:index]

    # Ratings
    resources :ratings, only: [:index]

    # Members
    resources :members, shallow: true do
      collection do
        get :new_request
      end
      member do
        get :approval
      end
    end
  end

  # Results
  get '/articles/:article_id/results' => 'results#index', as: :article_results
  get '/articles/:article_id/chart'   => 'results#chart', as: :article_chart

  # Visualization
  get '/articles/:article_id/viz'     => 'viz#index',    as: :article_viz
  get '/articles/:article_id/sankey'  => 'viz#sankey',   as: :article_sankey

  # Sensitivity Analysis 
  get '/articles/:article_id/sensitivity' => 'sensitivity#index',  as: :article_sensitivity
  get '/articles/:article_id/sensitivity_data' => 'sensitivity#data',  as: :article_sensitivity_data

  # Appraisal
  resources :appraisals, only: :destroy
  
  resources :criteria, only: [:show, :edit, :update, :destroy] do
    member do
      get :tree
      get 'new' => :new, as: :new
      post '' => :create, as: :create_sub
    end
    
    controller :direct_comparisons do
      get 'direct_comparisons/new'  => :new,    as: :new_direct_comparisons
      get 'direct_comparisons/edit' => :edit,   as: :edit_direct_comparisons
      post 'direct_comparisons'     => :create, as: :direct_comparisons
      patch 'direct_comparisons'    => :update
      put 'direct_comparisons'      => :update
    end

    controller :magiq_comparisons do
      get 'magiq_comparisons/new'  => :new,    as: :new_magiq_comparisons
      get 'magiq_comparisons/edit' => :edit,   as: :edit_magiq_comparisons
      post 'magiq_comparisons'     => :create, as: :magiq_comparisons
      patch 'magiq_comparisons'    => :update
      put 'magiq_comparisons'      => :update
    end

    controller :ahp_comparisons do
      get 'ahp_comparisons/new'  => :new,    as: :new_ahp_comparisons
      get 'ahp_comparisons/edit' => :edit,   as: :edit_ahp_comparisons
      post 'ahp_comparisons'     => :create, as: :ahp_comparisons
      patch 'ahp_comparisons'    => :update
      put 'ahp_comparisons'      => :update
    end

    controller :ratings do
      get 'ratings' => :show, as: :ratings
    end
  end

end

app/helpers/shared_helper.rb
module SharedHelper
  include ApplicationHelper

  # For error messages in alert
  def inflectize(n, noun)
    if n == 1
      noun
    else
      noun.pluralize
    end
  end

  def description_snippet(description, len=100)
    unless description.blank?
      doc = Nokogiri::HTML::DocumentFragment.parse description
      doc.css("h1,h2,h3,h4,h5,h6").each {|h| h.name = 'h5'}
      doc.css('img').remove
      doc.css('br').remove
      #doc.to_html.truncate(len)
      doc.to_html
    end
  end

  def pic_snippet(description)
    unless description.blank?
      pic_node = Nokogiri::HTML(description).at_css('img')
      pic_node[:src] unless pic_node.nil?
    end
  end

  def conditional_link_to(text=nil, path, cond, **opts, &block)
    if cond
      content_tag(:a, opts.merge(href: path)) { block_given? ? block.call : text }
    else
      opts.delete(:data)
      content_tag(:a, opts.merge(disabled: "disabled")) { block_given? ? block.call : text }
    end
  end

  def id_for_bookmark(article, marked)
    if marked
      "bookmark-#{article.id}"
    end
  end

end

app/views/shared/_app_menu.html.slim
-content_for :article_menu do
  - if article.nil? || !article.persisted?
    = render partial: 'shared/no_article_navbar'
  - else
    = render partial: 'shared/model_edit_navbar', 
              locals: { article: article }

app/views/shared/_flash_messages.html.slim
#flashes
  - flash.each do |type, message|
    div class="#{flash_class(type)}"
      a.close data-dismiss="alert" ×
      = message

app/views/shared/_model_edit_navbar.html.slim
.subnav.subnav-fixed
  ul.nav.nav-pills
    li.divider-left
    -if user_signed_in?
      li.dropdown
        a.dropdown-toggle href="/" data-toggle="dropdown" style="padding:10px 2px"
          i.icon-file
          b.caret
        ul.dropdown-menu.my-articles
          - if can? :create, Article
            li
              = link_to new_article_path do
                i.icon-edit
                |  Create new article
          li.divider
          li 
            = link_to my_articles_path
              strong My articles:
          li 
            ul#my-articles-list-menu
              - my_articles.each do |article|
                li = link_to article.title, article

    li class=link_status('articles')
      = link_to article_path(article)
        i.icon-file
        span  Article

    li class=link_status('alternatives', disabled:false)
      = link_to article_alternatives_path(article)
        i.icon-move
        span  Alternatives
    li class=link_status('criteria', disabled:false)
      = link_to article_criteria_path(article)
        i.icon-th-list
        span  Criteria
    li class=link_status('ratings', disabled:false)
      = link_to article_ratings_path(article)
        i.icon-random
        span  Rate

    li class=link_status(['results','sensitivity','viz'])
      a href=article_results_path(article)
        i.icon-bar-chart
        span  Results
    li.divider-right
    li.article-box
      span.article-label Article:
      span.title = link_to article.title, article

app/views/shared/_no_article_navbar.html.slim
.subnav.subnav-fixed
  ul.nav.nav-pills
    li.divider-left
    -if user_signed_in?
      li.dropdown
        a.dropdown-toggle href="/" data-toggle="dropdown" style="padding:10px 2px"
          i.icon-file
          b.caret
        ul.dropdown-menu.my-articles
          -if can? :create, Article
            li
              = link_to new_article_path do
                i.icon-edit
                |  Create new article
          li.divider
          li 
            = link_to my_articles_path
              strong My articles:
          li 
            ul#my-articles-list-menu
              - my_articles.each do |article|
                li = link_to article.title, article

    li.disable
      a 
        i.icon-file
        span  Article
    li.disable
      a
        i.icon-move
        span  Alternatives
    li.disable
      a
        i.icon-th-list
        span  Criteria
    li.disable
      a
        i.icon-random
        span  Rate
    li.disable 
      a
        i.icon-bar-chart
        span  Results
    li.divider-right

app/views/shared/_results_nav_menu.html.slim
- action = params[:action]

ul.nav.nav-pills.results
  = link_or_text('results', article_results_path(presenter.article, p: presenter.member_id), 'Ranking')
  = link_or_text('viz', article_viz_path(presenter.article, p: presenter.member_id), 'Visualization')
  = link_or_text('sensitivity', article_sensitivity_path(presenter.article, p: presenter.member_id), 'Sensitivity Analysis')

app/views/shared/_sidebar.html.slim
#sidebar
  .well.side-widget
    .side-widget-header
    .side-widget-title Follow
    .side-widget-content
      ul.social-icons
        li
          img src='/assets/social_icons/facebook.png' rel="tooltip" data-original-title="Facebook"
        li
          img src='/assets/social_icons/twitter.png' rel="tooltip" data-original-title="Twitter"
        li
          img src='/assets/social_icons/googleplus.png' rel="tooltip" data-original-title="Google+"

    .side-widget-divider
    .side-widget-content
      div style="margin:19px 0 10px 0; text-align:center"
        = link_to "Sign up, free", new_user_registration_path, class: "btn btn-primary btn-large"

div 
  .well.side-widget
    .side-widget-header
    .side-widget-title Sponsored
    .side-widget-content
      .thumbnails
        .thumbnail
          h5 Advertise here!

app/views/shared/_user_profile.html.slim
#sidepanel
  .well.side-widget
    .side-widget-header
    .side-widget-title User
    .side-widget-content
      .user-info
        .user-name
          = user.name
        .user-member-since
          i.icon-time
          span Member since
          = user.created_at.nil? ? "the beginning" : user.created_at.strftime("%B %Y")

    .side-widget-divider
    .side-widget-title Articles
    .side-widget-content
      ul.nav.nav-list.alt-list
        li.alternative.ui-state-default#article
          = link_to "Articles", user_path(user)+"?fn=article", class:"pjax"
        -if user.articles.private_articles.present?
          li.alternative.ui-state-default#particle
            = link_to "Private articles", user_path(user)+"?fn=particle", class:"pjax"
        li.alternative.ui-state-default#participating
          = link_to "Participating", user_path(user)+"?fn=participating"
        li.alternative.ui-state-default#bookmarks
          = link_to "Bookmarks", user_path(user)+"?fn=bookmarks"
      -if can? :create, Article
        = link_to new_article_path, class:'btn btn-primary btn-small' do
          i.icon-plus
          |  New article